#include <stdio.h>
#include <stdlib.h>

int main(int argc,char **argv)
{
if (argc<5)
	{
	printf("%d\n",argc);
	printf("Error : especifica un fichero y los datos !!\n");
	printf("histogram <inputfile> <minvalue> <maxvalue> <steps> [%c] \n",'%');
	printf("Si inputfile es '-' toma la entrada de stdin\n");
	return -1;
	};
int minval=atoi(argv[2]);
int maxval=atoi(argv[3]);
int steps=atoi(argv[4]);
FILE *fh;
if (strcmp(argv[1],"-")!=0)
   fh=fopen(argv[1],"r");
  else
   fh=stdin;
long *histogram=new long[steps+2];
for (int i=0;i<steps+2;i++) histogram[i]=0;
char s[200];
double d;
int pos;
while (!feof(fh))
    {
    fgets(s,150,fh);
    d=strtod(s,NULL);
    pos= (int)((double)steps*(double)((d-minval)/(double)(maxval-minval)));
    if (pos+1>=steps+1) pos=steps;
    if (pos<0) pos=-1;
    histogram[pos+1]++;
    };
if (strcmp(argv[1],"-")!=0) fclose(fh);
int i=-1;
if ((argc>=6)&&(strcmp(argv[5],"%")==0))
    {
    unsigned long maximo=0;
    while (i<steps+1) {maximo+=histogram[i+1];i++;};
    fprintf(stderr,"maximo = %lu\n",maximo);
    i=-1;
    while (i<steps+1)
	{
	printf("%g %g\n",
		(double)i*(double)(maxval-minval)/(double)steps+(double)minval,
		(double)histogram[i+1]/(double)maximo);
	i++;
	};    
    }
   else
    {
    while (i<steps+1)
	{
	printf("%g %ld\n",
		(double)i*(double)(maxval-minval)/(double)steps+(double)minval,
		histogram[i+1]);
	i++;
	};    
    };
delete histogram;
return 0;
};
